<?php
/*--------------------------------------------------------------------------------------*\
*|	Tutorial Script																		*|
*|	By			::	Parmeet Singh														*|
*|	Web-Site	::	http://www.phpwiz.net												*|
*|	Email		::	parmeet@phpwiz.net													*|
*|																						*|
*|	--------------------------------------------										*|
*|																						*|
*|	You are not allowed to distribute this script in any way.							*|
*|	This script is the property of Parmeet Singh.										*|
*|	You may not remove the copyright information unless you have special permission		*|
*|	from Parmeet Singh.																	*|
\*--------------------------------------------------------------------------------------*/


/*----- Start Functions class */

class Functions {

	function parse( $template ,$toparse = array() ) {
		GLOBAL $phpwiz,$root_path;
		$topen    = $root_path."admin/$template.php";
		$fp       = fopen( $topen , "r" );
		$contents = fread( $fp , filesize( $topen ) );
		fclose( $fp );

		foreach ( $toparse as $key => $value ) {
			$contents = str_replace( $key , $value , $contents );
		}
		return $contents;
 	}

	function in($field, $err = 0 , $min = 0, $max = 0)
	{
		global $phpwiz;

		$REQUEST	=	array_merge($_GET,$_POST);

		if($phpwiz->vars['html'] == 1) {
			$parse	=	0;
		}
		else {
			$parse	=	1;
		}

		if(!isset($REQUEST[$field])) {
			return "";
		}

		if($REQUEST[$field] == "" && $err == 1)
		{
			$phpwiz->print->error("The form field '$field' was not filed<br>");
		}
		else
		{

			$text	=	$REQUEST[$field];

			if($min != 0)
			{
				if(strlen($REQUEST[$field]) < $min)
				{
					$phpwiz->print->error("The form field '$field' must be atleast $min characters");
				}
			}

			if($max != 0)
			{
				if(strlen($REQUEST[$field] ) > $max)
				{
					$phpwiz->print->error("The form field '$field' must be leass tan $max characters");
				}
			}
			return $text;
		}

	}

	function redirect($msg,$link) {
		global $phpwiz;

		echo $this->parse("redirect",array(	"{bgcolor}"		=>	$phpwiz->vars['bgcolor'],
											"{tblwidth}"	=>	$phpwiz->vars['tbl_width'],
											"{tblbg}"		=>	$phpwiz->vars['tbl_color'],
											"{baseurl}"		=>	$phpwiz->base_url,
											"{msg}"			=>	$msg,
											"{link}"		=>	$link));
		exit;
	}

	function login() {
		global $phpwiz;

		$output	=	$this->parse("login",array(	"{baseurl}"		=>	$phpwiz->base_url,));
		echo $output;
		exit;
	}

	function dropdown($name,$a = array(),$s = "") {
		$m	=	"<select name='$name'>\n";

		if(is_array($a)) {
			foreach($a as $k => $v) {
				if($v == $s) {
					$m .= "<option value='$v' selected>$k</option>\n";
				}
				else {
					$m	.=	"<option value='$v'>$k</option>\n";
				}
			}
		}
		else {
			return false;
		}

		$m	.=	"</select>\n";

		return $m;
	}

	function delete($file_dir) {
		if(@file_exists($file_dir)) {
			@chmod($file_dir,0777);

			if (@is_dir($file_dir)) {
				$dir = @opendir($file_dir);

				while($filename = @readdir($dir)) {
					if ($filename != "." && $filename != "..") {
						$this->delete($file_dir."/".$filename);
					}
				}
				@closedir($dir);

				@rmdir($file_dir);

			}
			else {
				@unlink($file_dir);
			}
			return true;
		}
		else {
			return true;
		}
	}

	function copy1($from,$to) {
		@mkdir($to, 0777);

		$this_path = getcwd();

		if (is_dir($from)) {
			chdir($from);
			$handle	=	opendir('.');

			while (($file = readdir($handle)) != false) {

				if (($file != ".") && ($file != "..")) {
					if (is_dir($file)) {
						$this->copy1($from."/".$file, $to."/".$file);
						chdir($from);
					}

					if (is_file($file)) {
						copy($from."/".$file, $to."/".$file);
					}
				}
			}
			closedir($handle);
		}
		else {
			copy($from, $to);
		}
	}

	function check_ext($file) {

		$ext_array		=	explode( "." , $file );
		$ex				=	$ext_array[count($ext_array) - 1];
		$ex				=	strtolower($ex);

		if($ex == "pw") {
			return true;
		}
		else {
			return false;
		}
	}

}

/*----- End Functions class */

/*----- Start Print class */
class Output {
	var $output	=	"";
	var $title	=	"";
	var $nav	=	"";

	function _wrapper($content = "") {
		global $phpwiz,$Exec;

		if($this->title == "") {
			$this->title	=	$phpwiz->vars['title'];
		}

		if($this->nav == "") {
			$this->nav	=	"<a href='$phpwiz->base_url'>{$phpwiz->vars['title']} -  </a>";
		}

		$echo	=	$phpwiz->Func->parse( "maintmpl" , array(	"{title}"		=>	$this->title,
																"{baseurl}"		=>	$phpwiz->base_url,
																"{bgcolor}"		=>	$phpwiz->vars['bgcolor'],
																"{nav}"			=>	$this->nav,
																"{content}"		=>	$this->output,
																"{version}"		=>	$phpwiz->vars['version'],
																"{imageurl}"	=>	$phpwiz->vars['imageurl']));

		echo $echo;
		exit;
	}

	function error($error = "") {
		global $phpwiz;

		$this->nav	=	"<a href='$phpwiz->base_url'>{$phpwiz->vars['title']} -  </a> ";

		$this->title	=	$phpwiz->vars['title'] . "->Error";
		$this->output	=	$phpwiz->Func->parse( "error" , array("{error}"	=>	$error));

		$this->_wrapper();
		die;
	}

	function out($content = "") {
		global $phpwiz;

		if(is_array($content)) {
			$this->output = $content[0];

			$this->nav	=	"<a href='$phpwiz->base_url'>{$phpwiz->vars['title']}</a>";

			if(is_array($content[1])) {
				foreach($content[1] as $k => $v) {
					$this->nav	.=	" -> <a href='$phpwiz->base_url$v'>$k</a>";
				}
			}

		}
		else{
			$this->output	=	$content;
		}

		$this->_wrapper();
	}
}
/*----- End Print class */

?>